<template>
  <div>
    <div id="registration-name">
      <div class="step-heading">Как к вам обращаться?</div>
      <div class="row">
        <div class="col-xs-12">
          <ob-input
            label="Фамилия"
            placeholder="Фамилия"
            :required="true"
            v-model.trim="formData.user_lastname"
            @input="onChangeFormData('user_lastname')"
          />
        </div>
      </div>
      <div class="row">
        <div class="col-xs-6">
          <ob-input
            label="Имя"
            placeholder="Имя"
            :required="true"
            v-model.trim="formData.user_firstname"
            @input="onChangeFormData('user_firstname')"
          />
        </div>
        <div class="col-xs-6">
          <ob-input
            label="Отчество"
            placeholder="Если есть"
            v-model.trim="formData.user_middlename"
            @input="onChangeFormData('user_middlename')"
          />
        </div>
      </div>
    </div>
    <div class="step-heading">
      Выберите вашу систему налогообложения<sup>*</sup>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-radio
          label="Плательщик НДС"
          :valueInput="true"
          v-model="formData.vat"
          :disabled="registrarCountryCode !== 'rus'"
          data-qa="vat-true"
          @change="onChangeFormData('vat')"
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-12">
        <ob-radio
          label="Не плательщик НДС"
          :valueInput="false"
          v-model="formData.vat"
          :disabled="registrarCountryCode !== 'rus'"
          data-qa="vat-false"
          @change="onChangeFormData('vat')"
        />
      </div>
    </div>
    <div id="registration-activities">
      <div class="step-heading">
        Выберите, чем вы будете заниматься на платформе<sup>*</sup>
      </div>
      <div class="row">
        <div class="col-xs-12">
          <ob-radio
            id="registration-activities-orders"
            label="Размещать заказы"
            valueInput="formData.orders_placing"
            v-model="activitiesRadio"
            @change="onChangeCheckboxValue('orders_placing')"
          />
        </div>
      </div>
      <div class="row">
        <div class="col-xs-12">
          <ob-radio
            id="registration-activities-transportation"
            label="Перевозить грузы"
            valueInput="formData.transportation"
            v-model="activitiesRadio"
            @change="onChangeCheckboxValue('transportation')"
          />
        </div>
      </div>
      <!--<div class="row">
        <div class="col-xs-12">
          <ob-checkbox
            label="Привлекать заказчиков по агентскому соглашению"
            v-model="formData.agency_services"
            @change="onChangeCheckboxValue('agency_services')"
          />
        </div>
      </div>-->
    </div>
    <div v-if="accreditationFormData.activities.includes('transportation')">
      <div class="step-heading">Выберите вариант регистрации<sup>*</sup></div>
      <div class="row">
        <div class="col-xs-12">
          <ob-radio
            label="Полный доступ"
            :valueInput="false"
            v-model="formData.isLightRegistration"
            @change="onChangeRegistrationVariant(false)"
          />
        </div>
      </div>
      <div class="row">
        <div class="col-xs-12">
          <ob-radio
            label="Только для участия в трекинговых заказах"
            :valueInput="true"
            v-model="formData.isLightRegistration"
            @change="onChangeRegistrationVariant(true)"
            :disabled="true"
          />
        </div>
      </div>
    </div>

    <div class="row button-row">
      <div class="col-xs-12">
        <ob-button
          label="Продолжить"
          :isFullWidth="true"
          :disabled="isDisabled"
          @click="onSubmit"
        />
      </div>
    </div>

    <Tour :steps="steps" />
  </div>
</template>

<script>
  import api from '@/api'
  import { mapGetters, mapActions } from 'vuex';
  import VueCookie from 'vue-cookie'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObRadio from 'common-components/src/obComponents/obRadio'
  // import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
  import ObButton from 'common-components/src/obComponents/obButton'
  import Tour from '../components/Tour'

  export default {
    name: 'RegistrationThirdStep',
    components: {
      ObInput,
      ObRadio,
      ObButton,
      // ObCheckbox,
      Tour
    },
    computed: {
      ...mapGetters({
        accreditationFormData: 'entry/accreditationFormData',
        participantUuid: 'user/participantUuid'
      }),

      isDisabled: ({ accreditationFormData }) => {
        const requiredFields = (({ user_firstname, user_lastname }) => ({ user_firstname, user_lastname }))(accreditationFormData);
        return Object.values(requiredFields).some(value => !value) || !accreditationFormData.activities.length;
      },
      steps () {
        return [
          {
            target: '#registration-name',
            header: { title: 'ФИО' },
            content: 'При первой авторизации нужно заполнить ФИО. Это позволит ' +
                     'идентифицировать вас как уникального пользователя.',
            params: { placement: 'right', highlight: true }
          },
          {
            target: '#registration-activities',
            header: { title: 'Что вы будете делать?' },
            content: '<p>Выберите род деятельности.</p>' +
                     '<p>От этого будет зависеть тип вашей учетной записи - Заказчик или Перевозчик.</p>',
            params: { placement: 'right', highlight: true }
          },
          {
            target: '#registration-activities-orders',
            header: { title: 'Вы Заказчик?' },
            content: 'Выберите "Размещать заказы", если вы Заказчик и будете ' +
                     'размещать заказы, тендеры и споты, пользоваться трекингом.',
            params: { placement: 'right', highlight: true }
          },
          {
            target: '#registration-activities-transportation',
            header: { title: 'Вы Перевозчик?' },
            content: '<p>Вы перевозчик/экспедитор, ищете новых клиентов, выполняете заказы?</p>' +
                     '<p>Выберите "Перевозить грузы.</p>',
            params: { placement: 'right', highlight: true }
          }
        ]
      }
    },
    created() {
      this.formData = {
        ...this.accreditationFormData,
        orders_placing: this.accreditationFormData.activities.includes('orders_placing'),
        transportation: this.accreditationFormData.activities.includes('transportation'),
        agency_services: this.accreditationFormData.activities.includes('agency_services')
      };

      this.getRegistrarCountryCode();
    },
    data() {
      return {
        formData: {},
        activitiesRadio: 'active',
        registrationTypeRadio: 'active',
        registrarCountryCode: null
      }
    },
    methods: {
      ...mapActions({
        setAccreditationFormData: 'entry/setAccreditationFormData',
        setRegistrationDone: 'entry/setRegistrationDone',
        fetchMenu: 'functions/fetchMenu'
      }),

      async getRegistrarCountryCode() {
        const { countrySymbolCode } = await api.registration.register.getRegistrarCountryCode(this.participantUuid);
        this.registrarCountryCode = countrySymbolCode;
        if (this.registrarCountryCode !== 'rus') {
          this.formData.vat = true;
          this.onChangeFormData('vat');
        }
      },

      async onSubmit() {
        const { 
          activities, 
          user_lastname, 
          user_firstname, 
          user_middlename, 
          vat, 
          isLightRegistration 
        } = this.accreditationFormData;

        const payload = { 
          activities, 
          user_lastname, 
          user_firstname, 
          user_middlename, 
          vat,
          isLightRegistration
        };

        await api.registration.accreditation.setUserActivitiesAndPersonalData(payload);

        const token = VueCookie.get('refresh_token');

        try {
          const data = await api.registration.auth.refresh({ token });
          VueCookie.set('auth_token', data.token);
          VueCookie.set('refresh_token', data.refreshToken);

          this.fetchMenu();

          if (payload.isLightRegistration) {
            this.setRegistrationDone();
          } else {
            this.$emit('changeStep', 3);
          }

        } catch (e) {
          console.log(e);
        }
      },

      onChangeFormData(key) {
        const value = this.formData[key];
        this.setAccreditationFormData({ key, value });
      },

      onChangeCheckboxValue(key) {
        if (key === 'transportation') {
          this.setAccreditationFormData({ key: 'isLightRegistration', value: false });
          this.formData.isLightRegistration=false
        }else{
          this.setAccreditationFormData({ key: 'isLightRegistration', value: true });
          this.formData.isLightRegistration=true
        }
        const value = this.formData[key];
        let array = [...this.accreditationFormData.activities];
        value ? array.push(key) : array = array.filter(k => k !== key);
        /*array->key*/
        this.setAccreditationFormData({ key: 'activities', value: [key] });
      },

      onChangeRegistrationVariant(value) {
        this.setAccreditationFormData({ key: 'isLightRegistration', value });
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .row {
    margin-bottom: 20px;
  }

  .button-row {
    margin-top: 32px;
  }

  .step-heading {
    @include font-mixin(16px, 20px, 700, inherit, 0.4px);

    margin: 30px 0 10px;

    sup {
      color: $color-error;
    }
  }

</style>